"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var formater_1 = __importDefault(require("./formater"));
var Duration = /** @class */ (function () {
    function Duration(duration, unit) {
        if (unit === void 0) { unit = 'S'; }
        this.duration = duration;
        this.unit = unit;
        this._millisecond = Duration.convertToMillisecond(duration, unit);
    }
    Object.defineProperty(Duration.prototype, "millisecond", {
        get: function () {
            return this._millisecond;
        },
        enumerable: true,
        configurable: true
    });
    Duration.convertToMillisecond = function (value, type) {
        var millisecondValue = Duration.INPUT_TYPES.filter(function (v) { return v.type === type; })[0].millisecondValue;
        return value * millisecondValue;
    };
    Duration.prototype.format = function (token, option) {
        if (option === void 0) { option = {}; }
        var formatter = new formater_1.default(this, token, option);
        return formatter.format();
    };
    Duration.FORMAT_TOKENS = /\*?[Hh]|\*?m+|\*?s+|./g;
    Duration.INPUT_TYPES = [
        {
            type: 'S',
            millisecondValue: 1,
        },
        {
            type: 's',
            millisecondValue: 1000,
        },
        {
            type: 'm',
            millisecondValue: 60000,
        },
        {
            type: 'h',
            millisecondValue: 3600000,
        },
    ];
    return Duration;
}());
exports.default = Duration;
